#define _GNU_SOURCE
#include <pthread.h>
#include <err.h>
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/mman.h>
#include <sys/prctl.h>

#ifndef MREMAP_DONTUNMAP
#define MREMAP_DONTUNMAP 4
#endif

#define SYSCHK(x) ({          \
  typeof(x) __res = (x);      \
  if (__res == (typeof(x))-1L) \
    err(1, "SYSCHK(" #x ")"); \
  __res;                      \
})

static char *area;
static volatile int fault_thread_done;
static volatile int spin_launch;

static void *fault_thread(void *dummy) {
  while (!spin_launch) /*spin*/;
  SYSCHK(prctl(PR_SET_NAME, "SLOWME"));
  area[0] = 1;
  SYSCHK(prctl(PR_SET_NAME, "noslow"));
  fault_thread_done = 1;
  return NULL;
}

int main(void) {
  fault_thread_done = 0;

  area = SYSCHK(mmap((void*)0x10000, 0x1000, PROT_READ|PROT_WRITE, MAP_ANONYMOUS|MAP_PRIVATE|MAP_FIXED_NOREPLACE, -1, 0));
  char *area2 = SYSCHK(mmap((void*)0x11000, 0x1000, PROT_READ|PROT_WRITE|PROT_EXEC, MAP_ANONYMOUS|MAP_PRIVATE|MAP_FIXED_NOREPLACE, -1, 0));
  char *area3 = SYSCHK(mmap((void*)0x12000, 0x1000, PROT_NONE, MAP_ANONYMOUS|MAP_PRIVATE|MAP_FIXED_NOREPLACE, -1, 0));
  area[0] = '1'; // create anon_vma
  SYSCHK(madvise(area, 0x1000, MADV_DONTNEED)); // zap page

  pthread_t thread;
  if (pthread_create(&thread, NULL, fault_thread, NULL))
    errx(1, "pthread_create");
  sleep(1);

  spin_launch = 1;
  sleep(1);
  SYSCHK(mremap(area, 0x1000, 0x1000, MREMAP_MAYMOVE|MREMAP_FIXED|MREMAP_DONTUNMAP, area3));
  // fault_thread still before vma lock
  sleep(2);
  SYSCHK(munmap(area3, 0x1000));
  sleep(5);
}
